typedef unsigned long ref;
typedef signed long sref;

#ifdef __GNUC__
#define NONRET __attribute__((noreturn))
#else
#define NONRET
#endif

#define INT_MAX (sref)((~(ref)0) >> 4u)

#ifdef __GNUC__ 
#include <alloca.h>
#define ST_ALLOC alloca
#define ST_FREE(p)
#else
#define ST_ALLOC xmalloc
#define ST_FREE(p) free(p)
#endif
